[top]
components : Residential Highway Commercial Factory FerryBoat
link : out1@Factory in2@Residential
link : out1@Factory in2@Highway
link : out1@Highway in1@Residential
link : out2@Highway in1@Factory
link : out3@Highway in1@FerryBoat
link : out4@Highway in1@Commercial
link : out1@FerryBoat in1@Highway
link : out2@FerryBoat in2@Commercial
link : out1@Commercial in3@Highway
link : out2@Commercial in2@FerryBoat

% Coloco una cola para encolar los camiones que van llegando y se van poniendo en cola en el
% estacionamiento para procesar la carga y descarga se modela con un DEV - QUEUE
% Luego simulo una descarga y carga de Mercaderia con un modelo DEV - CPU
% Cuando sale de la cola un camion se demora un tiempo aleatorio entre

[Factory]
components : TruckParking@queue TruckWorking@CPU
in : in1
out : out1
Link : in1 in@TruckParking
Link : out@TruckParking in@TruckWorking
Link : out@TruckWorking out1
Link : out@TruckWorking done@TruckParking

[TruckParking]
preparation : 00:00:00:000

[TruckWorking]
distribution : normal
mean : 18
deviation : 2

% Este submodelo me general el trafico de automoviles desde dos islas diferentes hacia la
% Autopista y hacia el Centro Comercial, se utiliza el modelo DEV - Generator con una
% distribucin Poisson para simular los automoviles en intervalos de tiempo

[FerryBoat]
components : fromIslandA@Generator fromIslandB@Generator
in : in1 in2
out : out1 out2
Link : out@fromIslandA out1
Link : out@fromIslandB out2

[fromIslandA]
distribution : poisson
mean : 25
initial : 1
increment : 0

[fromIslandB]
distribution : poisson
mean : 29
initial : 1
increment : 0

% En este submodelo se define mediante un modelos Cell-Devs el comportamiento de particulas
% de smog en una zona residencial, la particularidad de este modelo es que tiene una demora
% inercial, lo que nos permite simular la influencia del viento sobre dichas particulas

[Residential]
type : cell
width : 10
height : 9
delay : inertial
defaultDelayTime : 2000
border : nowrapped 
neighbors : Residential(-1,-1) Residential(-1,0) Residential(-1,1)
neighbors : Residential(0,-1)  Residential(0,0)  Residential(0,1)
neighbors : Residential(1,-1)  Residential(1,0)  Residential(1,1)
initialValue : 0
initialrowvalue :  0    0000000000
initialrowvalue :  1    0000000000
initialrowvalue :  2    0000000000
initialrowvalue :  3    0000000000
initialrowvalue :  4    0000000000
initialrowvalue :  5    0000000000
initialrowvalue :  6    0000000000
initialrowvalue :  7    0000000000
initialrowvalue :  8    0000000000
in : in1 in2
link : in1 in@Residential(8,7)
link : in2 in@Residential(8,9)
localtransition : ResidentialPollution

% Esta reglas tienen en cuenta la accion del viento que viene en
% direccion noroeste

[ResidentialPollution]
rule : 1 2000 { (0,0) = 0 and ((1,0)=1 or (1,1)=1) and statecount(1)=1 }
rule : 1 2000 { (0,0) = 0 and ((0,1)=1 or (-1,1)=1) and statecount(1)=2 }
rule : 1 2000 { (0,0) = 0 and ((0,1)=1 or (1,-1)=1) and statecount(1)=3 }
rule : 0 2000 { (0,0) = 1 and statecount(1) > 3  }
rule : 0 2000 { t }


% Este submodelo simula al movimiento de automoviles en una zona comercial

[Commercial]
type : cell
width : 10
height : 10
delay : transport
defaultDelayTime  : 5000
border : nowrapped 
neighbors :                   Commercial(-1,0)
neighbors : Commercial(0,-1)  Commercial(0,0)  Commercial(0,1)
neighbors :                   Commercial(1,0)  Commercial(1,1)
initialvalue : 0
initialrowvalue :  0      0000000000 
initialrowvalue :  1      0001110000
initialrowvalue :  2      0100200000
initialrowvalue :  3      0020200000
initialrowvalue :  4      0000200000
initialrowvalue :  5      0000000000
initialrowvalue :  6      0000000000
initialrowvalue :  7      0000000000
initialrowvalue :  8      0000000000
initialrowvalue :  9      0000000000
in : in1 in2
out : out1 out2
link : in1 in@Commercial(9,4)
link : in2 in@Commercial(5,1)
link : out@Commercial(0,9) out1 
link : out@Commercial(4,9) out2 
localTransition : TransitCommercial

# 1 para autos que van hacia la derecha
# 2 para autos que van hacia arriba
# 0 significa que no hay autos
# Hay dos reglas que a los autos que vienen con direccion arriba (=2)
# se le cambia automaticamente a 1 para que quede homogeneo el sistema
# Tener en cuenta que esto puede ser argumentado como que la unica manera
# de acceder al puente que une la autopista y el Ferry es doblando a la derecha

[TransitCommercial]
% Estas dos primeras reglas me cambian la direccion aleatoreamente de los autos
% que ingresan al modelo
rule : {randint(1)+1} 5000 { (0,0)=1 and cellpos(0)=5 and cellpos(1)=1 }
rule : {randint(1)+1} 5000 { (0,0)=1 and cellpos(0)=9 and cellpos(1)=4 }
% Estas dos que siguen sirven para cambiar el rumbo de determinados autos
% debido a ciertas inquietudes comerciales de algunos automovilistas dada
% una gran campaa de marketing
rule : {randint(1)+1} 5000 { (0,0)=1 and cellpos(0)=5 and cellpos(1)=6 }
rule : {randint(1)+1} 5000 { (0,0)=2 and cellpos(0)=4 and cellpos(1)=4 }
rule : 2  5000  { (0,0) = 2 and ((-1,0) != 0 and (-1,0) != ?) }
rule : 1  5000  { (0,0) = 0 and (1,0) = 2 and cellpos(0)=0 and cellpos(1)=9}
rule : 1  5000  { (0,0) = 0 and (1,0) = 2 and cellpos(0)=4 and cellpos(1)=9}
rule : 2  5000  { (0,0) = 0 and (1,0) = 2 }
rule : 0  5000  { (0,0) = 2 and ((-1,0) = 0 or (-1,0) = ?) }
rule : 1  5000  { (0,0) = 1 and (0,1) = 0 and (1,1) = 2 }
rule : 1  5000  { (0,0) = 1 and ((0,1) != 0 and (0,1) != ?)}
rule : 1  5000  { (0,0) = 0 and (0,-1) = 1 }
rule : 0  5000  { (0,0) = 1 and ((0,1) = 0 or (0,1) = ?) }
rule : 0  5000  { (0,0) = 0 }
rule : {(0,0)} 5000 {t}


% Este submodelo simula el movimiento de automoviles y camiones circulando por una autopista

[Highway]
type : cell
width : 15
height : 4
delay : transport
defaultDelayTime : 2000
border : nowrapped
initialValue : 0
neighbors : Highway(-1,-1) Highway(-1,0) Highway(-1,1)  
neighbors : Highway(0,-1)  Highway(0,0)  Highway(0,1)   
neighbors : Highway(1,-1)  Highway(1,0)  Highway(1,1)
initialrowvalue :  0    000100000000000
initialrowvalue :  1    000010001000000
initialrowvalue :  2    001000010001010
initialrowvalue :  3    000000000010000
in : in1 in2 in3
out : out1 out2 out3 out4
link : out@Highway(0,9) out3
link : out@Highway(1,14) out2
link : out@Highway(2,5) out1
link : out@Highway(3,3) out4
link : in1 in@Highway(2,0)
link : in2 in@Highway(1,10)
link : in3 in@Highway(3,4)
localtransition : TransitHighway

[TransitHighway]
rule : 1 2000 { (0,0)=0 and (0,-1)=1}
rule : 0 2000 { (0,0)=1 and ((0,1)=0 or (0,1)=?) }

rule : 1 2000 { (0,0)=0 and (0,-1)=0 and (1,-1)=1 and (1,0)=1 }
rule : 0 2000 { (0,0)=1 and (0,1)=1 and (-1,1)=0 and (-1,0)=0 }

rule : 1 2000 { (0,0)=0 and (0,-1)=0 and (-1,-1)=1 and (-1,0)=1}
rule : 0 2000 { (0,0)=1 and (0,1)=1 and (1,1)=0 and (-1,1)=1 and (1,0)=0 }

rule : 1 2000 { (0,0)=1 and (-1,1)=1 and (0,1)=1 and (1,1)=1 }
rule : 0 2000 { (0,0)=0 }

rule : 0 2000 {t}